forked from fishercoder1534/Leetcode
-
Notifications
You must be signed in to change notification settings - Fork 0
/
_480.java
108 lines (90 loc) · 3.37 KB
/
_480.java
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89
90
91
92
93
94
95
96
97
98
99
100
101
102
103
104
105
106
107
108
package com.fishercoder.solutions;
import java.util.Collections;
import java.util.PriorityQueue;
/**
* 480. Sliding Window Median
*
* Median is the middle value in an ordered integer list. If the size of the list is even, there is no middle value. So the median is the mean of the two middle value.
Examples:
[2,3,4] , the median is 3
[2,3], the median is (2 + 3) / 2 = 2.5
Given an array nums, there is a sliding window of size k which is moving from the very left of the array to the very right.
You can only see the k numbers in the window. Each time the sliding window moves right by one position.
Your job is to output the median array for each window in the original array.
For example,
Given nums = [1,3,-1,-3,5,3,6,7], and k = 3.
Window position Median
--------------- -----
[1 3 -1] -3 5 3 6 7 1
1 [3 -1 -3] 5 3 6 7 -1
1 3 [-1 -3 5] 3 6 7 -1
1 3 -1 [-3 5 3] 6 7 3
1 3 -1 -3 [5 3 6] 7 5
1 3 -1 -3 5 [3 6 7] 6
Therefore, return the median sliding window as [1,-1,-1,3,5,6].
Note:
You may assume k is always valid, ie: 1 ≤ k ≤ input array's size for non-empty array.
*/
public class _480 {
public static class Solution1 {
/**
* You cannot simply use minus sign '-' to denote the descending order, because e.g. 3 and -3 might both exist in this array,
* so we'll have to use the original numbers themselves to store in the heaps.
*/
private PriorityQueue<Integer> minHeap = new PriorityQueue<>();
private PriorityQueue<Integer> maxHeap = new PriorityQueue<>(Collections.reverseOrder());
public double[] medianSlidingWindow(int[] nums, int k) {
int n = nums.length - k + 1;
if (n <= 0) {
return new double[0];
}
double[] result = new double[n];
for (int i = 0; i <= nums.length; i++) {
if (i >= k) {
result[i - k] = getMedian();
remove(nums[i - k]);
}
if (i < nums.length) {
add(nums[i]);
}
}
return result;
}
private double getMedian() {
if (maxHeap.isEmpty() && minHeap.isEmpty()) {
return 0;
}
if (maxHeap.size() == minHeap.size()) {
return ((double) maxHeap.peek() + (double) minHeap.peek()) / 2.0;
} else {
return (double) minHeap.peek();
}
}
private void remove(int num) {
if (num < getMedian()) {
maxHeap.remove(num);
} else {
minHeap.remove(num);
}
if (maxHeap.size() > minHeap.size()) {
minHeap.add(maxHeap.poll());
}
if (minHeap.size() - maxHeap.size() > 1) {
maxHeap.add(minHeap.poll());
}
}
private void add(int num) {
if (num < getMedian()) {
maxHeap.add(num);
} else {
minHeap.add(num);
}
if (maxHeap.size() > minHeap.size()) {
minHeap.add(maxHeap.poll());
}
if (minHeap.size() - maxHeap.size() > 1) {
maxHeap.add(minHeap.poll());
}
}
}
}